class ActivityPolicy < ApplicationPolicy
  class Scope < Scope
    attr_reader :user, :scope

    def initialize(user, scope)
      @user  = user
      @scope = scope
    end

    def resolve
      raise StandardError, 'The user must be set.' if user.blank?
      if user.is_admin?
        scope.includes(:owner).order('created_at DESC').all
      else
        user.activities
      end
    end
  end

  def index?
    true
  end

  ## only user followers can see your activities
  def user_activities?
    record if user.following? record
  end
end
