class ReviewSerializer < ActiveModel::Serializer

  def rating_average
    object.rating_average
  end

  def rated
    object.rated?(current_user)
  end

  def approves
    object.user_approves? current_user
  end

  attributes :id, :name, :description, :pros, :cons, :rating_average, :rates_count, :created_at, :updated_at, :reviewable, :reviewable_type, :rated, :approves
  has_many :review_ratings
  belongs_to :user
end
