  require 'rainbow'
  require 'logger'

namespace :import do

  desc "Create educational stage relations based on its metadata"
  task :educational_stage, [:log] => [:environment] do |t, args|
  
  logger = Logger.new(STDOUT)
  educational_relations = []

    EducationalStage.all.each do |educational|
      logger.info("Creating relations of #{educational.name}")

      if tag_exists?(educational.name)
        tag = Tag.find_by_name(educational.name)
      else
        tag = Tag.create(name: educational.name)
      end

      tag.taggings.each do |tagging|
            educational_relation = StageRelation.new(educational_stage: educational, stageable_id: tagging.taggable_id, stageable_type: tagging.taggable_type)
            educational_relations << educational_relation
      end

    end
  

    StageRelation.import educational_relations  
  end

  private

  def tag_exists? (name)
    Tag.where(name: name).exists?
  end

end
