require 'test_helper'

class V1::CollectionsControllerTest < ActionController::TestCase
  tests V1::CollectionsController
  include Devise::Test::ControllerHelpers

  test 'should get index' do
    skip('Unsolved issue: ArgumentError: wrong number of arguments (2 for 0)')
  end

  test 'should user post collection to create and return :created code' do
    auth_request users(:jack)
    post :create, params: { collection: { name: 'my collection',
                                         description: 'testing collection',
                                         owner_type: 'User', owner_id: users(:jack).id,
                                         items: [{id: learning_objects(:user_lo).id, type: "LearningObject"}]}
                          }
    assert_response :created
  end

  test 'should institution post collection to create and return :created code' do
    auth_request users(:jack)
    post :create, params: { collection: { name: 'my collection',
                               description: 'testing collection',
                               owner_type: 'Institution', owner_id: institutions(:ufpr).id,
                               items: [{id: learning_objects(:user_lo).id, type: "LearningObject"}]}
                          }
    assert_response :created
  end

  test 'should user post collection to create and return :unauthorized code' do
    post :create, params: { collection: {name: 'my collection',
                               description: 'testing collection',
                               owner_type: 'Institution', owner_id: institutions(:ufpr).id }
                             }
    assert_response :unauthorized
  end

  test 'should user tagging a collection' do
    auth_request users(:jack)
    tag = tags(:tag_three).name

    post :tagging, params: { id: collections(:ufpr).id, tag: { name: tag, owner_id: users(:jack).id, owner_type: 'User' } }
    assert_response :created
  end


  test 'should user untagging a collection' do
    auth_request users(:john)
    tag = tags(:tag_one).name

    post :untagging, params: { id: collections(:ufpr).id, tag: { name: tag, owner_id: users(:jack).id, owner_type: 'User' } }
    assert_response :ok
  end


  test 'should institution tagging a collection' do
    auth_request users(:jack)
    institution = institutions(:ufpr)
    institution.users << users(:jack)
    tag = tags(:tag_one).name

    post :tagging, params: { id: collections(:ufpr).id, tag: { name: tag, owner_id: institutions(:ufpr).id, owner_type: 'Institution' } }
    assert_response :created
  end

  test 'should institution untagging a collection' do
    auth_request users(:john)
    institution = institutions(:ufpr)
    institution.users << users(:john)
    tag = tags(:tag_two).name

    delete :untagging, params: { id: collections(:ufpr).id, tag: { name: tag , owner_id: institutions(:ufpr).id, owner_type: 'Institution' } }
    assert_response :ok
  end


  private

  def ensure_collection_is_persisted!(collection)
    collection.save!
  end
end
