require 'test_helper'

class V1::LicensesControllerTest < ActionController::TestCase
  tests V1::LicensesController
  include Devise::Test::ControllerHelpers

  setup do
    @license = licenses(:one)
  end

  test "should get index" do
    skip
    get :index
    assert_response :success
    assert_not_nil assigns(:licenses)
  end

  test "should create license" do
    auth_request users(:admin)

    assert_difference('License.count') do
      post :create, params: { license: { description: @license.description, name: @license.name, url: @license.url, image_url: @license.image_url } }
    end

    assert_response 201
  end

  test "should show license" do
    skip
    get :show, id: @license
    assert_response :success
  end

  test "should update license" do
    auth_request users(:admin)

    put :update, params: { id: @license, license: { description: @license.description, name: @license.name, url: @license.url, image_url: @license.image_url } }
    assert_response 204
  end

  test "should destroy license" do
    auth_request users(:admin)

    assert_difference('License.count', -1) do
      delete :destroy, params: { id: @license }
    end

    assert_response 204
  end
end
